package ub.pfc.formugram;

import java.util.ArrayList;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.TextView;

/**
 * Classe principal de l'aplicaci
 * @author Oriol Jans
 *
 */
public class FormuGramActivity extends Activity
{

	private TextView formula;
	private TriangleAdapter adaptador;
	private ArrayList<Triangle> ts;
	private DrawView dv;

	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);

		setContentView(R.layout.main);

		ts = new ArrayList<Triangle>();

		formula = (TextView)findViewById(R.id.textView1);

		adaptador =	new TriangleAdapter(this, ts);
		ListView lstOpciones = (ListView)findViewById(R.id.listView1);
		lstOpciones.setAdapter(adaptador);

		lstOpciones.setOnItemClickListener(new OnItemClickListener()
		{
			public void onItemClick(AdapterView<?> a, View v, int position, long id) {
				editVariable(position);
			}
		});

		dv = (DrawView)findViewById(R.id.DrawView1);
	}

	public void refreshFormule(String formule)
	{
		formula.setText(formule);
	}

	public void refreshList(ArrayList<Triangle> ts)
	{
		this.ts.clear();
		this.ts.addAll(ts);

		adaptador.notifyDataSetChanged();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu)
	{
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.main_menu, menu);
		return true;
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item)
	{
		switch (item.getItemId())
		{
			case R.id.reset:
				dv.reset();
				return true;
			case R.id.info:
				showInfo();
				return true;
			case R.id.exit:
				this.finish();
				return true;
			default:
				return super.onOptionsItemSelected(item);
		}
	}

	public void showInfo()
	{
		new AlertDialog.Builder(this)
		.setTitle("FormuGram")
		.setIcon(R.drawable.icon962)
		.setMessage("Application created by Oriol Jans Pereira.")
		.setPositiveButton(android.R.string.ok, null)
		.show();
	}

	public void editVariable(int pos)
	{
		final int n = pos;
		AlertDialog.Builder builder = new AlertDialog.Builder(this);
		final EditText et = new EditText(this);
		builder.setMessage("New name:")
			.setView(et)
			.setCancelable(false)
			.setPositiveButton("Change", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id)
				{
					Triangle t = ts.get(n);
					t.customVar(et.getText().toString());
					dv.invalidate();
					adaptador.notifyDataSetChanged();
						dv.refreshFormule();
					dialog.dismiss();
				}
			})
			.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					dialog.cancel();
				}
			});
		AlertDialog alert = builder.create();
		alert.show();
	}
}