package ub.pfc.formugram;

import java.text.DecimalFormat;
import java.util.ArrayList;

import android.app.Activity;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

/**
 * Classe utilitzada per refrescar la barra lateral
 * @author Qxit
 *
 */
class TriangleAdapter extends ArrayAdapter<Triangle> {

	private static final DecimalFormat df = new DecimalFormat("0.00");
	Activity context;
	ArrayList<Triangle> ts;

	static class ViewHolder
	{
		TextView value;
	}

	TriangleAdapter(Activity context, ArrayList<Triangle> ts) {
		super(context, R.layout.adapter, ts);
		this.ts = ts;
		this.context = context;
	}

	public View getView(int position, View convertView, ViewGroup parent)
	{
		View item = convertView;
		ViewHolder holder;

		if(item == null)
		{
			LayoutInflater inflater = context.getLayoutInflater();
			item = inflater.inflate(R.layout.adapter, null);

			holder = new ViewHolder();
			holder.value = (TextView)item.findViewById(R.id.textView2);

			item.setTag(holder);
		}
		else
		{
			holder = (ViewHolder)item.getTag();
		}

		holder.value.setText(ts.get(position).getVarName() + " = " + df.format(ts.get(position).getValue()));

		float type = ts.get(position).getType();

		if (convertView != null)
		{
			if (type == 1) convertView.setBackgroundColor(Color.BLUE);
			else if (type == 2) convertView.setBackgroundColor(Color.RED);
			else convertView.setBackgroundColor(Color.TRANSPARENT);
		}

		return(item);
	}

}